diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-downlink-power-control.h ns-3.31/src/lte/test/lte-test-downlink-power-control.h
--- ns-3.30.1/src/lte/test/lte-test-downlink-power-control.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-downlink-power-control.h	2020-06-27 17:38:30.000000000 -0700
@@ -75,7 +75,7 @@
  * \param expected the expected Tx Power Spectral Density
  */
   LteDownlinkPowerControlSpectrumValueTestCase (std::string name,
-                                                uint16_t earfcn, uint8_t bw, double powerTx,
+                                                uint16_t earfcn, uint16_t bw, double powerTx,
                                                 std::map<int, double> powerTxMap, std::vector <int> activeRbs,
                                                 SpectrumValue& expected);
   virtual ~LteDownlinkPowerControlSpectrumValueTestCase ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-fdbet-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-fdbet-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-fdbet-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-fdbet-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -211,6 +211,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   /**
    * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
@@ -279,7 +283,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "FD blind equal throughput" manner
+   * Check that the downlink assignment is done in a "FD blind equal throughput" manner
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
@@ -293,7 +297,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)dlDataRxed.at (i) << "  thr " << (double)dlDataRxed.at (i) / statsDuration << " ref " << m_thrRefDl);
     }
   /**
-  * Check that the assignation is done in a "FD blind equal throughput" manner among users
+  * Check that the assignment is done in a "FD blind equal throughput" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
@@ -304,7 +308,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "FD blind equal throughput" manner
+  * Check that the uplink assignment is done in a "FD blind equal throughput" manner
   */
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> ulDataRxed;
@@ -318,7 +322,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)ulDataRxed.at (i) << "  thr " << (double)ulDataRxed.at (i) / statsDuration << " ref " << m_thrRefUl);
     }
   /**
-  * Check that the assignation is done in a "FD blind equal throughput" manner among users
+  * Check that the assignment is done in a "FD blind equal throughput" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
@@ -376,6 +380,10 @@
       Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
     }
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (false));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   /**
   * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
@@ -464,7 +472,7 @@
   estTotalThr = m_nUser * (1 / estTotalThr);
   estUeThr = estTotalThr / m_nUser;
   /**
-  * Check that the assignation is done in a "FD blind equal throughput" manner among users
+  * Check that the assignment is done in a "FD blind equal throughput" manner among users
   * with different SINRs: the bandwidth should be distributed equally in long term
   */
   for (int i = 0; i < m_nUser; i++)
@@ -478,7 +486,7 @@
     }
 
   /**
-  * Check that the assignation in uplink is done in a round robin manner.
+  * Check that the assignment in uplink is done in a round robin manner.
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-fdmt-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-fdmt-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-fdmt-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-fdmt-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -192,6 +192,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   /**
    * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
@@ -262,7 +266,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "frequency domain maximum throughput" manner
+   * Check that the downlink assignment is done in a "frequency domain maximum throughput" manner
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
@@ -276,7 +280,7 @@
     }
 
   /**
-  * Check that the assignation is done in a "frequency domain maximum throughput" manner among users
+  * Check that the assignment is done in a "frequency domain maximum throughput" manner among users
   * with maximum SINRs: without fading, current FD MT always assign all resources to one UE
   */
 
@@ -298,7 +302,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "proportional fair" manner
+  * Check that the uplink assignment is done in a "proportional fair" manner
   */
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> ulDataRxed;
@@ -312,7 +316,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)ulDataRxed.at (i) << "  thr " << (double)ulDataRxed.at (i) / statsDuration << " ref " << m_thrRefUl);
     }
   /**
-  * Check that the assignation is done in a "proportional fair" manner among users
+  * Check that the assignment is done in a "proportional fair" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-fdtbfq-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-fdtbfq-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-fdtbfq-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-fdtbfq-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -270,6 +270,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -430,7 +434,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "token bank fair queue" manner
+   * Check that the downlink assignment is done in a "token bank fair queue" manner
    */
 
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -452,7 +456,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "round robin" manner
+  * Check that the uplink assignment is done in a "round robin" manner
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
@@ -520,7 +524,10 @@
     }
 
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
-
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper>  epcHelper = CreateObject<PointToPointEpcHelper> ();
@@ -680,7 +687,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "token bank fair queue" manner
+   * Check that the downlink assignment is done in a "token bank fair queue" manner
    */
 
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s)");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-frequency-reuse.cc ns-3.31/src/lte/test/lte-test-frequency-reuse.cc
--- ns-3.30.1/src/lte/test/lte-test-frequency-reuse.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-frequency-reuse.cc	2020-06-27 17:38:30.000000000 -0700
@@ -175,7 +175,7 @@
 }
 
 LteFrTestCase::LteFrTestCase (std::string name,
-                              uint32_t userNum,uint8_t dlBandwidth,uint8_t ulBandwidth,
+                              uint32_t userNum,uint16_t dlBandwidth,uint16_t ulBandwidth,
                               std::vector<bool> availableDlRb, std::vector<bool> availableUlRb)
   : TestCase ("Test: " + name),
     m_userNum (userNum),
@@ -242,9 +242,9 @@
 
 LteHardFrTestCase::LteHardFrTestCase (std::string name, uint32_t userNum,
                                       std::string schedulerType,
-                                      uint8_t dlBandwidth, uint8_t ulBandwidth,
-                                      uint8_t dlSubBandOffset, uint8_t dlSubBandwidth,
-                                      uint8_t ulSubBandOffset, uint8_t ulSubBandwidth,
+                                      uint16_t dlBandwidth, uint16_t ulBandwidth,
+                                      uint8_t dlSubBandOffset, uint16_t dlSubBandwidth,
+                                      uint8_t ulSubBandOffset, uint16_t ulSubBandwidth,
                                       std::vector<bool> availableDlRb, std::vector<bool> availableUlRb)
   : LteFrTestCase (name, userNum, dlBandwidth, ulBandwidth, availableDlRb, availableUlRb),
     m_schedulerType (schedulerType),
@@ -357,9 +357,9 @@
 
 LteStrictFrTestCase::LteStrictFrTestCase (std::string name, uint32_t userNum,
                                           std::string schedulerType,
-                                          uint8_t dlBandwidth, uint8_t ulBandwidth,
-                                          uint8_t dlCommonSubBandwidth, uint8_t dlEdgeSubBandOffset, uint8_t dlEdgeSubBandwidth,
-                                          uint8_t ulCommonSubBandwidth, uint8_t ulEdgeSubBandOffset, uint8_t ulEdgeSubBandwidth,
+                                          uint16_t dlBandwidth, uint16_t ulBandwidth,
+                                          uint16_t dlCommonSubBandwidth, uint8_t dlEdgeSubBandOffset, uint16_t dlEdgeSubBandwidth,
+                                          uint16_t ulCommonSubBandwidth, uint8_t ulEdgeSubBandOffset, uint16_t ulEdgeSubBandwidth,
                                           std::vector<bool> availableDlRb, std::vector<bool> availableUlRb)
   : LteFrTestCase (name, userNum, dlBandwidth, ulBandwidth, availableDlRb, availableUlRb),
     m_schedulerType (schedulerType),
@@ -1508,7 +1508,7 @@
   Config::SetDefault ("ns3::LteEnbRrc::RsrqFilterCoefficient",
                       UintegerValue (0));
 
-  uint8_t bandwidth = 25;
+  uint16_t bandwidth = 25;
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   Ptr<PointToPointEpcHelper> epcHelper = CreateObject<PointToPointEpcHelper> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-frequency-reuse.h ns-3.31/src/lte/test/lte-test-frequency-reuse.h
--- ns-3.30.1/src/lte/test/lte-test-frequency-reuse.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-frequency-reuse.h	2020-06-27 17:38:30.000000000 -0700
@@ -64,7 +64,7 @@
    * \param availableUlRb the available UL per RB
    */
   LteFrTestCase (std::string name,
-                 uint32_t userNum,uint8_t dlBandwidth,uint8_t ulBandwidth,
+                 uint32_t userNum,uint16_t dlBandwidth,uint16_t ulBandwidth,
                  std::vector<bool> availableDlRb, std::vector<bool> availableUlRb);
   virtual ~LteFrTestCase ();
 
@@ -83,8 +83,8 @@
   virtual void DoRun (void);
 
   uint32_t m_userNum; ///< the number of UE nodes
-  uint8_t m_dlBandwidth; ///< the DL bandwidth
-  uint8_t m_ulBandwidth; ///< the UL bandwidth
+  uint16_t m_dlBandwidth; ///< the DL bandwidth
+  uint16_t m_ulBandwidth; ///< the UL bandwidth
 
   std::vector<bool> m_availableDlRb; ///< the available DL for each RB
   bool m_usedMutedDlRbg; ///< used muted DL RBG?
@@ -121,9 +121,9 @@
    */
   LteHardFrTestCase (std::string name, uint32_t userNum,
                      std::string schedulerType,
-                     uint8_t dlBandwidth, uint8_t ulBandwidth,
-                     uint8_t dlSubBandOffset, uint8_t dlSubBandwidth,
-                     uint8_t ulSubBandOffset, uint8_t ulSubBandwidth,
+                     uint16_t dlBandwidth, uint16_t ulBandwidth,
+                     uint8_t dlSubBandOffset, uint16_t dlSubBandwidth,
+                     uint8_t ulSubBandOffset, uint16_t ulSubBandwidth,
                      std::vector<bool> availableDlRb, std::vector<bool> availableUlRb);
   virtual ~LteHardFrTestCase ();
 
@@ -168,9 +168,9 @@
    */
   LteStrictFrTestCase (std::string name, uint32_t userNum,
                        std::string schedulerType,
-                       uint8_t dlBandwidth, uint8_t ulBandwidth,
-                       uint8_t dlCommonSubBandwidth, uint8_t dlEdgeSubBandOffset, uint8_t dlEdgeSubBandwidth,
-                       uint8_t ulCommonSubBandwidth, uint8_t ulEdgeSubBandOffset, uint8_t ulEdgeSubBandwidth,
+                       uint16_t dlBandwidth, uint16_t ulBandwidth,
+                       uint16_t dlCommonSubBandwidth, uint8_t dlEdgeSubBandOffset, uint16_t dlEdgeSubBandwidth,
+                       uint16_t ulCommonSubBandwidth, uint8_t ulEdgeSubBandOffset, uint16_t ulEdgeSubBandwidth,
                        std::vector<bool> availableDlRb, std::vector<bool> availableUlRb);
   virtual ~LteStrictFrTestCase ();
 
@@ -179,13 +179,13 @@
 
   std::string m_schedulerType; ///< scheduler type
 
-  uint8_t m_dlCommonSubBandwidth; ///< DL common subbandwidth
+  uint16_t m_dlCommonSubBandwidth; ///< DL common subbandwidth
   uint8_t m_dlEdgeSubBandOffset; ///< DL edge subband offset
-  uint8_t m_dlEdgeSubBandwidth; ///< DL edge subbandwidth
+  uint16_t m_dlEdgeSubBandwidth; ///< DL edge subbandwidth
 
-  uint8_t m_ulCommonSubBandwidth; ///< UL common subbandwidth
+  uint16_t m_ulCommonSubBandwidth; ///< UL common subbandwidth
   uint8_t m_ulEdgeSubBandOffset; ///< UL edge subband offset
-  uint8_t m_ulEdgeSubBandwidth; ///< UL edge subbandwidth
+  uint16_t m_ulEdgeSubBandwidth; ///< UL edge subbandwidth
 };
 
 /**
@@ -263,8 +263,8 @@
 
   std::string m_schedulerType; ///< the scheduler type
  
-  uint8_t m_dlBandwidth; ///< the DL bandwidth
-  uint8_t m_ulBandwidth; ///< the UL bandwidth
+  uint16_t m_dlBandwidth; ///< the DL bandwidth
+  uint16_t m_ulBandwidth; ///< the UL bandwidth
 
   Time m_teleportTime; ///< the telport time
   Ptr<MobilityModel> m_ueMobility; ///< the UE mobility model
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-harq.cc ns-3.31/src/lte/test/lte-test-harq.cc
--- ns-3.30.1/src/lte/test/lte-test-harq.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-harq.cc	2020-06-27 17:38:30.000000000 -0700
@@ -110,6 +110,12 @@
   Config::SetDefault ("ns3::LteSpectrumPhy::CtrlErrorModelEnabled", BooleanValue (false));
   Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (true));
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
+
+
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
 
@@ -240,7 +246,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the assignation is done in a RR fashion
+   * Check that the assignment is done in a RR fashion
    */
   NS_LOG_INFO ("\tTest on downlink data shared channels (PDSCH)");
   NS_LOG_INFO ("Test with " << m_nUser << " user(s) at distance " << m_dist << " expected Thr " << m_throughputRef);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-ipv6-routing.cc ns-3.31/src/lte/test/lte-test-ipv6-routing.cc
--- ns-3.30.1/src/lte/test/lte-test-ipv6-routing.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-ipv6-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -185,7 +185,11 @@
           sourcePort = udpHeader2.GetSourcePort ();
           destinationPort = udpHeader2.GetDestinationPort ();
           //Check whether the uids, addresses and ports match
-          if ((p2->GetUid () == p1->GetUid ()) && sorceAddress.IsEqual (ipv6header1.GetDestinationAddress ()) && destinationAddress.IsEqual (ipv6header1.GetSourceAddress ()) && sourcePort == udpHeader1.GetDestinationPort () && destinationPort == udpHeader1.GetSourcePort ())
+          if ((p2->GetUid () == p1->GetUid ())
+              && sorceAddress == ipv6header1.GetDestinationAddress ()
+              && destinationAddress == ipv6header1.GetSourceAddress ()
+              && sourcePort == udpHeader1.GetDestinationPort ()
+              && destinationPort == udpHeader1.GetSourcePort ())
             {
               b = true;
               break;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-link-adaptation.cc ns-3.31/src/lte/test/lte-test-link-adaptation.cc
--- ns-3.30.1/src/lte/test/lte-test-link-adaptation.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-link-adaptation.cc	2020-06-27 17:38:30.000000000 -0700
@@ -160,6 +160,10 @@
   Config::SetDefault ("ns3::LteAmc::Ber", DoubleValue (0.00005));
   Config::SetDefault ("ns3::LteEnbRrc::SrsPeriodicity", UintegerValue (2));
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
@@ -170,8 +174,6 @@
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
 //   lteHelper->EnableLogComponents ();
-  lteHelper->EnableMacTraces ();
-  lteHelper->EnableRlcTraces ();
   lteHelper->SetAttribute ("PathlossModel", StringValue ("ns3::ConstantSpectrumPropagationLossModel"));
   NS_LOG_INFO ("SNR = " << m_snrDb << "  LOSS = " << m_loss);
   lteHelper->SetPathlossModelAttribute ("Loss", DoubleValue (m_loss));
@@ -214,6 +216,9 @@
   Config::Connect ("/NodeList/0/DeviceList/0/ComponentCarrierMap/*/LteEnbMac/DlScheduling",
                    MakeBoundCallback (&LteTestDlSchedulingCallback, this));
 
+  lteHelper->EnableMacTraces ();
+  lteHelper->EnableRlcTraces ();
+
   Simulator::Stop (Seconds (0.040));
   Simulator::Run ();
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-mimo.cc ns-3.31/src/lte/test/lte-test-mimo.cc
--- ns-3.30.1/src/lte/test/lte-test-mimo.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-mimo.cc	2020-06-27 17:38:30.000000000 -0700
@@ -116,6 +116,10 @@
   Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
   Config::SetDefault ("ns3::LteAmc::AmcModel", EnumValue (LteAmc::PiroEW2010));
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (m_useIdealRrc));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-pathloss-model.cc ns-3.31/src/lte/test/lte-test-pathloss-model.cc
--- ns-3.30.1/src/lte/test/lte-test-pathloss-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-pathloss-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -193,6 +193,10 @@
 void
 LtePathlossModelSystemTestCase::DoRun (void)
 {
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
   /**
   * Simulation Topology
   */
@@ -201,8 +205,6 @@
 
   Ptr<LteHelper> lteHelper = CreateObject<LteHelper> ();
   //   lteHelper->EnableLogComponents ();
-  lteHelper->EnableMacTraces ();
-  lteHelper->EnableRlcTraces ();
   lteHelper->SetAttribute ("PathlossModel", StringValue ("ns3::HybridBuildingsPropagationLossModel"));
 
   // set frequency. This is important because it changes the behavior of the path loss model
@@ -270,6 +272,9 @@
    
 //   Config::Connect ("/NodeList/0/DeviceList/0/LteEnbMac/DlScheduling",
 //                    MakeBoundCallback (&LteTestPathlossDlSchedCallback, this));
+
+  lteHelper->EnableMacTraces ();
+  lteHelper->EnableRlcTraces ();
                    
   Simulator::Stop (Seconds (0.035));
   Simulator::Run ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-pf-ff-mac-scheduler.cc ns-3.31/src/lte/test/lte-test-pf-ff-mac-scheduler.cc
--- ns-3.30.1/src/lte/test/lte-test-pf-ff-mac-scheduler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-pf-ff-mac-scheduler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -230,6 +230,10 @@
       Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
     }
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (true));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   /**
    * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
@@ -301,7 +305,7 @@
   Simulator::Run ();
 
   /**
-   * Check that the downlink assignation is done in a "proportional fair" manner
+   * Check that the downlink assignment is done in a "proportional fair" manner
    */
   NS_LOG_INFO ("DL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> dlDataRxed;
@@ -314,7 +318,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)dlDataRxed.at (i) << "  thr " << (double)dlDataRxed.at (i) / statsDuration << " ref " << m_thrRefDl);
     }
   /**
-  * Check that the assignation is done in a "proportional fair" manner among users
+  * Check that the assignment is done in a "proportional fair" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
@@ -325,7 +329,7 @@
     }
 
   /**
-  * Check that the uplink assignation is done in a "proportional fair" manner
+  * Check that the uplink assignment is done in a "proportional fair" manner
   */
   NS_LOG_INFO ("UL - Test with " << m_nUser << " user(s) at distance " << m_dist);
   std::vector <uint64_t> ulDataRxed;
@@ -339,7 +343,7 @@
       NS_LOG_INFO ("\tUser " << i << " imsi " << imsi << " bytes rxed " << (double)ulDataRxed.at (i) << "  thr " << (double)ulDataRxed.at (i) / statsDuration << " ref " << m_thrRefUl);
     }
   /**
-  * Check that the assignation is done in a "proportional fair" manner among users
+  * Check that the assignment is done in a "proportional fair" manner among users
   * with equal SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user; therefore equally 
   * partitioning the whole bandwidth achievable from a single users in a TTI
@@ -395,6 +399,10 @@
       Config::SetDefault ("ns3::LteSpectrumPhy::DataErrorModelEnabled", BooleanValue (false));
     }
   Config::SetDefault ("ns3::LteHelper::UseIdealRrc", BooleanValue (false));
+  Config::SetDefault ("ns3::MacStatsCalculator::DlOutputFilename", StringValue (CreateTempDirFilename ("DlMacStats.txt")));
+  Config::SetDefault ("ns3::MacStatsCalculator::UlOutputFilename", StringValue (CreateTempDirFilename ("UlMacStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
 
   /**
   * Initialize Simulation Scenario: 1 eNB and m_nUser UEs
@@ -479,7 +487,7 @@
     }
 
   /**
-  * Check that the assignation is done in a "proportional fair" manner among users
+  * Check that the assignment is done in a "proportional fair" manner among users
   * with different SINRs: the bandwidth should be distributed according to the 
   * ratio of the estimated throughput per TTI of each user.
   */
@@ -492,7 +500,7 @@
     }
 
   /**
-  * Check that the assignation in uplink is done in a round robin manner.
+  * Check that the assignment in uplink is done in a round robin manner.
   */
 
   NS_LOG_INFO ("UL - Test with " << m_nUser);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lte/test/lte-test-phy-error-model.cc ns-3.31/src/lte/test/lte-test-phy-error-model.cc
--- ns-3.30.1/src/lte/test/lte-test-phy-error-model.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lte/test/lte-test-phy-error-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -324,6 +324,9 @@
   Config::SetDefault ("ns3::RrFfMacScheduler::HarqEnabled", BooleanValue (false));
   Config::SetGlobal ("RngRun", UintegerValue (m_rngRun));
 
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::DlRlcOutputFilename", StringValue (CreateTempDirFilename ("DlRlcStats.txt")));
+  Config::SetDefault ("ns3::RadioBearerStatsCalculator::UlRlcOutputFilename", StringValue (CreateTempDirFilename ("UlRlcStats.txt")));
+
   //Disable Uplink Power Control
   Config::SetDefault ("ns3::LteUePhy::EnableUplinkPowerControl", BooleanValue (false));
 
